## opm-simulators 2021.10

=== CMakeLists.txt ===
###########################################################################
#                                                                         #
# Note: The bulk of the build system is located in the cmake/ directory.  #
#       This file only contains the specializations for this particular   #
#       project. Most likely you are interested in editing one of these   #
#       files instead:                                                    #
#                                                                         #
#       dune.module                              Name and version number  #
#       CMakeLists_files.cmake                   Path of source files     #
#       cmake/Modules/${project}-prereqs.cmake   Dependencies             #
#                                                                         #
###########################################################################

# Mandatory call to project

project(opm-simulators C CXX)

cmake_minimum_required (VERSION 3.10)


option(SIBLING_SEARCH "Search for other modules in sibling directories?" ON)
set( USE_OPENMP_DEFAULT OFF ) # Use of OpenMP is considered experimental
option(BUILD_FLOW "Build the production oriented flow simulator?" ON)
option(BUILD_FLOW_BLACKOIL_ONLY "Build the production oriented flow simulator only supporting the blackoil model?" OFF)
option(BUILD_FLOW_VARIANTS "Build the variants for flow by default?" OFF)
option(BUILD_EBOS "Build the research oriented ebos simulator?" ON)
option(BUILD_EBOS_EXTENSIONS "Build the variants for various extensions of ebos by default?" OFF)
option(BUILD_EBOS_DEBUG_EXTENSIONS "Build the ebos variants which are purely for debugging by default?" OFF)
option(BUILD_FLOW_POLY_GRID "Build flow blackoil with polyhedral grid" OFF)
option(OPM_ENABLE_PYTHON "Enable python bindings?" OFF)
option(OPM_ENABLE_PYTHON_TESTS "Enable tests for the python bindings?" ON)
option(ENABLE_FPGA "Enable FPGA kernels integration?" OFF)

if(SIBLING_SEARCH AND NOT opm-common_DIR)
  # guess the sibling dir
  get_filename_component(_leaf_dir_name ${PROJECT_BINARY_DIR} NAME)
  get_filename_component(_parent_full_dir ${PROJECT_BINARY_DIR} DIRECTORY)
  get_filename_component(_parent_dir_name ${_parent_full_dir} NAME)
  #Try if <module-name>/<build-dir> is used
  get_filename_component(_modules_dir ${_parent_full_dir} DIRECTORY)
  if(IS_DIRECTORY ${_modules_dir}/opm-common/${_leaf_dir_name})
    set(opm-common_DIR ${_modules_dir}/opm-common/${_leaf_dir_name})
  else()
    string(REPLACE ${PROJECT_NAME} opm-common _opm_common_leaf ${_leaf_dir_name})
    if(NOT _leaf_dir_name STREQUAL _opm_common_leaf
        AND IS_DIRECTORY ${_parent_full_dir}/${_opm_common_leaf})
      # We are using build directories named <prefix><module-name><postfix>
      set(opm-common_DIR ${_parent_full_dir}/${_opm_common_leaf})
    elseif(IS_DIRECTORY ${_parent_full_dir}/opm-common)
      # All modules are in a common build dir
      set(opm-common_DIR "${_parent_full_dir}/opm-common")
    endif()
  endif()
endif()
if(opm-common_DIR AND NOT IS_DIRECTORY ${opm-common_DIR})
  message(WARNING "Value ${opm-common_DIR} passed to variable"
    " opm-common_DIR is not a directory")
endif()

find_package(opm-common REQUIRED)

include(OpmInit)
OpmSetPolicies()

# not the same location as most of the other projects? this hook overrides
macro (dir_hook)
endmacro (dir_hook)

# project information is in dune.module. Read this file and set variables.
# we cannot generate dune.module since it is read by dunecontrol before
# the build starts, so it makes sense to keep the data there then.
include (OpmInit)

# Look for the opm-tests repository; if found the variable
# HAVE_OPM_TESTS will be set to true.
include(Findopm-tests)

# list of prerequisites for this particular project; this is in a
# separate file (in cmake/Modules sub-directory) because it is shared
# with the find module
include ("${project}-prereqs")

# Make sure we are using the same compiler underneath
# NVCC as for the rest. In the case that NVCC does not support
# that compiler it will error out. Unfortunately this will only
# work for CMake >= 3.8. We found no way to make FindCUDA.cmake error
# out. It seems to ignore CMAKE_NVCC_FLAGS and CMAKE. Additionally
# our way of specifying cuda source files never worked for CMake
# version < 3.8. Hence we deactivate cuda for these versions.
# We use "CMAKE_VERSION VERSION_GREATER 3.7.9" instead of
# CMAKE_VERSION VERSION_GREATER_EQUAL 3.8, because of backwards
# compatibility to cmake 3.6 and lower.
if(NOT CMAKE_DISABLE_FIND_PACKAGE_CUDA AND
    CMAKE_VERSION VERSION_GREATER 3.7.9)
  if(CMAKE_BUILD_TYPE)
    set(_flags_suffix "_${CMAKE_BUILD_TYPE}")
  endif()
  if(NOT DEFINED ENV{CUDAHOSTCXX} AND NOT DEFINED CMAKE_CUDA_HOST_COMPILER AND
      (NOT CMAKE_CUDA_FLAGS${_flags_suffix} OR NOT CMAKE_CUDA_FLAGS${_flags_suffix} MATCHES ".*-ccbin .*"))
    message(STATUS "Setting CUDA host compiler CMAKE_CUDA_HOST_COMPILER to ${CMAKE_CXX_COMPILER} to "
      "prevent incompatibilities. Note that this might report that there "
      "is not CUDA compiler if your system's CUDA compiler does not support "
      "${CMAKE_CXX_COMPILER}.")
    # check_language does not seem to care about ${CMAKE_CUDA_FLAGS} or $(CUDA_NVCC_FLAGS}.
    # Hence we set CMAKE_CUDA_HOST_COMPILER to our C++ compiler.
    # In check_language(CUDA) we will get an error if we in addition put
    # "-ccbin ${CMAKE_CXX_COMPILER}" into CMAKE_CUDA_FLAGS. It results
    # in "${NVCC} -ccbin=${CMAKE_CXX_COMPILER}   -ccbin ${CMAKE_CXX_COMPILER}"
    # which causes nvcc to abort
    set(CMAKE_CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})
    set(ENV{CUDAHOSTCXX} ${CMAKE_CUDA_HOST_COMPILER}) # The only thing honored by check_language(CUDA)!
  endif()
  include(CheckLanguage)
  check_language(CUDA)
  if(CMAKE_CUDA_COMPILER)
    # OPTIONAL is ignored. Hence the magic above to check whether enabling CUDA works
    enable_language(CUDA OPTIONAL)
    # While the documentation says that it is deprecated, FindCUDA seems the
    # only easy way to determine the cublas and cusparse libraries.
    # Hence we call it unconditionally
    # The WellContributions kernel uses __shfl_down_sync, which was introduced in CUDA 9.0
    find_package(CUDA)
  endif()
  if(CUDA_FOUND AND CUDA_VERSION VERSION_LESS "9.0")
    set(CUDA_FOUND OFF)
    message(WARNING "Deactivating CUDA as we require version 9.0 or newer."
      " Found only CUDA version ${CUDA_VERSION}.")
  endif()
endif()

if(CUDA_FOUND)
  set(HAVE_CUDA 1)
  include_directories(${CUDA_INCLUDE_DIRS})
endif()

find_package(OpenCL)

# include FPGA target only when ENABLE_FPGA is set to ON
if(ENABLE_FPGA)
  # must include opencl.h which is a wrapper for all the OpenCL extensions
  find_file(OPENCL_H CL/opencl.h HINTS ${OpenCL_INCLUDE_DIRS})

  # FIXME: devise a check for the presence of the "FPGA" module; currently looking for makefile in <opm-simulators>/../FPGA
  find_file(FPGA_MODULE linearalgebra/ilu0bicgstab/xilinx/alveo_u280/vitis_20192/OPM-integration/makefile HINTS ${opm-simulators_SOURCE_DIR}/../FPGA)

  # this code only runs if the user explicitly enabled the FPGA
  # hence fatal_error instead of warning
  if(NOT OPENCL_H OR NOT OpenCL_FOUND)
    set(HAVE_FPGA 0)
    message(FATAL_ERROR " OpenCL packages/headers were not found. Make sure CL/opencl.h exists or deactivate FPGA.")
  elseif(NOT FPGA_MODULE)
    set(HAVE_FPGA 0)
    message(FATAL_ERROR " FPGA module was not found. Make sure FPGA repository exists or deactivate FPGA.")
  elseif(NOT DEFINED ENV{XILINX_XRT})
    # Xilinx XRT must be installed and properly setup
    set(HAVE_FPGA 0)
    message(FATAL_ERROR " Xilinx XRT not found. Make sure it is installed and setup (check its documentation) or deactivate FPGA.")
  else()
    set(HAVE_FPGA 1)
    message(STATUS "FPGA library and kernel integration active.")

    # FIXME: set the correct path to the FPGA module
    set(FPGA_SOURCE_DIR ${opm-simulators_SOURCE_DIR}/../FPGA)

    # configuration variables with default values: they can be overridden on the cmake command line
    # FPGA_PORTS_CONFIG selects the kernel's memory ports configuration; must be in sync with available kernel bitstream
    if(NOT FPGA_PORTS_CONFIG)
      set(FPGA_PORTS_CONFIG 2r_3r3w_ddr)
    endif()
    # FPGA_DEBUG_LEVEL sets the debug messages level for FPGA library functions (should be set to 0 for Release build)
    if(NOT FPGA_DEBUG_LEVEL)
      set(FPGA_DEBUG_LEVEL 0)
    endif()
    message(STATUS "Using the following settings for the FPGA library compilation: "
      "FPGA_PORTS_CONFIG=${FPGA_PORTS_CONFIG}, "
      "FPGA_DEBUG_LEVEL=${FPGA_DEBUG_LEVEL}")
    add_compile_options(-DPORTS_CONFIG=PORTS_${FPGA_PORTS_CONFIG})
    add_compile_options(-DBDA_DEBUG_LEVEL=${FPGA_DEBUG_LEVEL})
    # include directories for the FPGA library
    include_directories(${FPGA_SOURCE_DIR})
    include_directories(${FPGA_SOURCE_DIR}/linearalgebra/ilu0bicgstab/xilinx/src/sda_app)
    include_directories(${FPGA_SOURCE_DIR}/linearalgebra/ilu0bicgstab/xilinx/src/sda_app/common)
    # add external project to compile the FPGA library
    include (ExternalProject)
    ExternalProject_Add(FPGA_library
      # force the build step to always be run because source dependencies cannot be made explicit
      BUILD_ALWAYS 1
      DOWNLOAD_COMMAND ""
      UPDATE_COMMAND ""
      CONFIGURE_COMMAND ""
      BUILD_COMMAND make
        -f ${FPGA_SOURCE_DIR}/linearalgebra/ilu0bicgstab/xilinx/alveo_u280/vitis_20192/OPM-integration/makefile
        SRCDIR=${FPGA_SOURCE_DIR}/linearalgebra/ilu0bicgstab/xilinx/src/sda_app
        PORTS_CONFIG=${FPGA_PORTS_CONFIG}
        DEBUG_LEVEL=${FPGA_DEBUG_LEVEL}
      INSTALL_COMMAND ""
      TEST_COMMAND ""
    )
  endif()
endif()

if(OpenCL_FOUND)
  # the current OpenCL implementation relies on cl2.hpp, not cl.hpp
  # make sure it is available, otherwise disable OpenCL
  find_file(CL2_HPP CL/cl2.hpp HINTS ${OpenCL_INCLUDE_DIRS})
  if(CL2_HPP)
    set(HAVE_OPENCL 1)
    include_directories(${OpenCL_INCLUDE_DIRS})
  else()
    message(WARNING " OpenCL was found, but this version of opm-simulators relies on CL/cl2.hpp, which implements OpenCL 1.0, 1.1 and 1.2.\n Deactivating OpenCL")
    set(OpenCL_FOUND OFF)
    set(OPENCL_FOUND OFF)
  endif()
endif()

find_package(amgcl)
if(amgcl_FOUND)
  set(HAVE_AMGCL 1)
  # Linking to target angcl::amgcl drags in OpenMP and -fopenmp as a compile
  # flag. With that nvcc fails as it does not that flag.
  # Hence we set AMGCL_INCLUDE_DIRS.
  get_property(AMGCL_INCLUDE_DIRS TARGET amgcl::amgcl PROPERTY INTERFACE_INCLUDE_DIRECTORIES)
  include_directories(SYSTEM ${AMGCL_INCLUDE_DIRS})
endif()

if(OpenCL_FOUND)
  find_package(VexCL)
  if(VexCL_FOUND)
    set(HAVE_VEXCL 1)
    # generator expressions in vexcl do not seem to work and therefore
    # we cannot use the imported target. Hence we exract the needed info
    # from the targets
    get_property(VEXCL_INCLUDE_DIRS TARGET VexCL::Common PROPERTY INTERFACE_INCLUDE_DIRECTORIES)
    get_property(VEXCL_LINK_LIBRARIES TARGET VexCL::Common PROPERTY INTERFACE_LINK_LIBRARIES)
    get_property(VEXCL_COMPILE_DEFINITIONS TARGET VexCL::OpenCL PROPERTY INTERFACE_COMPILE_DEFINITIONS)
    set(VEXCL_LINK_LIBRARIES "${VEXCL_LINK_LIBRARIES};OpenCL::OpenCL")
    add_library(OPM::VexCL::OpenCL INTERFACE IMPORTED)
    set_target_properties(OPM::VexCL::OpenCL PROPERTIES
      INTERFACE_COMPILE_DEFINITIONS "${VEXCL_COMPILE_DEFINITIONS}"
      INTERFACE_LINK_LIBRARIES "${VEXCL_LINK_LIBRARIES}")
    target_include_directories(OPM::VexCL::OpenCL SYSTEM INTERFACE "${VEXCL_INCLUDE_DIRS}")
  endif()
endif()

# read the list of components from this file (in the project directory);
# it should set various lists with the names of the files to include
include (CMakeLists_files.cmake)

macro (config_hook)
  opm_need_version_of ("dune-common")
  opm_need_version_of ("dune-istl")
  if(dune-fem_FOUND)
      opm_need_version_of ("dune-fem")
  endif()
  opm_need_version_of ("opm-models")

=== python/CMakeLists.txt ===
find_package(pybind11 2.2 CONFIG)

if(NOT pybind11_FOUND)
  add_subdirectory( pybind11 )
  # SYSTEM is supported for embedded pybind source (>= 2.3.0)
  set(PYBIND11_SYSTEM "SYSTEM")
elseif(pybind11_VERSION VERSION_GREATER_EQUAL "2.3.0")
  # SYSTEM is only support for pybind >= 2.3.0 (Unfortunately querying the
  # version does not work. AT least we know the embedded one.
  set(PYBIND11_SYSTEM "SYSTEM")
endif()
add_subdirectory( simulators )

=== python/simulators/CMakeLists.txt ===
# NOTE: we assume that add_subdirectory( pybind11 ) is called from the
#    parent folder's CMakeLists.txt before this CMakeLists.txt is loaded.
#    Therefore, pybind11's CMakeLists.txt has already run
#    find_package(PYTHON) to define variables like ${PYTHON_EXECUTABLE}
#
# NOTE: The variable ${PYBIND11_SYSTEM} is set in python/CMakeLists.txt
#   to the value "SYSTEM" or unset, depending on the current version of Pybind11.
#   The value is then forwarded to target_include_directories(), see
#
#  https://cmake.org/cmake/help/latest/command/target_include_directories.html
#  https://pybind11.readthedocs.io/en/stable/compiling.html
#
pybind11_add_module(simulators ${PYBIND11_SYSTEM}
  PyBlackOilSimulator.cpp
  Pybind11Exporter.cpp)

set_target_properties( simulators PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/python/opm2 )

target_sources(simulators
  PRIVATE
  $<TARGET_OBJECTS:moduleVersion>
  $<TARGET_OBJECTS:flow_libblackoil>)

target_link_libraries( simulators PRIVATE opmsimulators )

set(PYTHON_PACKAGE_PATH "site-packages")
set(PYTHON_INSTALL_PREFIX "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/${PYTHON_PACKAGE_PATH}" CACHE STRING "Subdirectory to install Python modules in")

install(TARGETS simulators DESTINATION ${DEST_PREFIX}${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL_PREFIX}/opm)

file( COPY ${PROJECT_SOURCE_DIR}/python/test
      DESTINATION ${PROJECT_BINARY_DIR}/python)
file( COPY ${PROJECT_SOURCE_DIR}/python/test_data
      DESTINATION ${PROJECT_BINARY_DIR}/python)

if(OPM_ENABLE_PYTHON_TESTS)
  if(Python3_EXECUTABLE AND NOT PYTHON_EXECUTABLE)
    set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})
  endif()
  set(PYTHON_PATH ${PROJECT_BINARY_DIR}/python:${opm-common_DIR}/python:$ENV{PYTHONPATH})
  # NOTE: See comment in test_basic.py for the reason why we are
  #   splitting the python tests into multiple add_test() tests instead
  #   of having a single "python -m unittest" test call that will run all
  #   the tests in the "test" sub directory.
  add_test(NAME python_basic
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/python
      COMMAND ${CMAKE_COMMAND}
      -E env PYTHONPATH=${PYTHON_PATH} ${PYTHON_EXECUTABLE}
      -m unittest test/test_basic.py)
  add_test(NAME python_schedule
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/python
      COMMAND ${CMAKE_COMMAND}
      -E env PYTHONPATH=${PYTHON_PATH} ${PYTHON_EXECUTABLE}
      -m unittest test/test_schedule.py)
endif()

=== debian/changelog ===
opm-simulators (2021.10-4ubuntu1) jammy; urgency=medium

  * Build with reduced parallelism and disable LTO to
    avoid FTBFS in Ubuntu

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 09 Mar 2022 11:47:11 +0000

opm-simulators (2021.10-4) unstable; urgency=medium

  * d/tests: Added Restrictions: skip-not-installable

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 22 Feb 2022 19:15:14 +0530

opm-simulators (2021.10-3) unstable; urgency=medium

  * d/tests: run flow test in $AUTOPKGTEST_TMP
  * d/tests: Added python tests.

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 21 Feb 2022 20:28:20 +0530

opm-simulators (2021.10-2) unstable; urgency=medium

  * d/control: Remove g++ from Build-Depends
  * d/control: Build on any architecture.
  * d/control: Added dependency on libboost-date-time-dev to dev pkg.
  * Added autopkgtest for flow binary

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 17 Feb 2022 00:15:46 +0100

opm-simulators (2021.10-1) unstable; urgency=medium

  * Initial release (Closes: #987381)

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 16 Nov 2021 23:07:59 +0100

=== debian/control ===
Source: opm-simulators
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
Build-Depends: debhelper-compat (= 13), cmake (>=3.10), quilt, dh-python,
               libboost-system-dev, libboost-date-time-dev, libboost-test-dev,
               gfortran, pkg-config, git, libtool, doxygen,
               texlive-latex-extra, texlive-latex-recommended, ghostscript,
               libopm-grid-dev (>=2021.10), libopm-models-dev (>=2021.10),  mpi-default-dev, mpi-default-bin,
               python3-dev, libpython3-dev, python3-distutils, pybind11-dev
Standards-Version: 4.6.0
Section: libs
Homepage: http://opm-project.org
Vcs-Browser: https://salsa.debian.org/science-team/opm-simulators
Vcs-Git: https://salsa.debian.org/science-team/opm-simulators.git
Rules-Requires-Root: no

Package: libopm-simulators-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>=2021.10),
         libopm-models-dev (>=2021.10), libboost-date-time-dev
Replaces: libopm-simulators1-dev
Suggests: libopm-simulators-doc
Description: Parallel porous media / reservoir simulators -- development files
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 opm-simulators provides a research (ebos) and a production (flow) fully
 implicit black-oil simulators, supporting one to three phases and
 supporting solvent and polymer options. It uses cell centered finite
 volume schemes with two point flux approximation and automatic
 differentiation for the discretization and uses state of the art linear
 and nonlinear solvers. It supports standard and multi segment well
 models and reading and writing file in Eclipse format, a very common
 format used in the oil reservoir simulation community.
 .
 Package provides the development files (headers and shared library links).

Package: libopm-simulators
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Provides: ${opm:shared-library}
Replaces: libopm-simulators1
Description: Open porous media / reservoir simulators -- library
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 opm-simulators provides a research (ebos) and a production (flow) fully
 implicit black-oil simulators, supporting one to three phases and
 supporting solvent and polymer options. It uses cell centered finite
 volume schemes with two point flux approximation and automatic
 differentiation for the discretization and uses state of the art linear
 and nonlinear solvers. It supports standard and multi segment well
 models and reading and writing file in Eclipse format, a very common
 format used in the oil reservoir simulation community.
 .
 Package provides the library used by the research (ebos) and production
 (flow) fully implicit  black-oil simulators.

Package: libopm-simulators-bin
Section: science
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libopm-simulators1-bin
Description: Parallel porous media / reservoir simulators -- applications
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 opm-simulators provides a research (ebos) and a production (flow) fully
 implicit black-oil simulators, supporting one to three phases and
 supporting solvent and polymer options. It uses cell centered finite
 volume schemes with two point flux approximation and automatic
 differentiation for the discretization and uses state of the art linear
 and nonlinear solvers. It supports standard and multi segment well
 models and reading and writing file in Eclipse format, a defacto
 industry standard in the oil reservoir simulation community.
 .
 Package provides the simulation programs.

Package: libopm-simulators-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: libopm-simulators-doc
Description: Open porous media / reservoir simulators -- documentation
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 opm-simulators provides a research (ebos) and a production (flow) fully
 implicit black-oil simulators, supporting one to three phases and
 supporting solvent and polymer options. It uses cell centered finite
 volume schemes with two point flux approximation and automatic
 differentiation for the discretization and uses state of the art linear
 and nonlinear solvers. It supports standard and multi segment well
 models and reading and writing file in Eclipse format, a very common
 format used in the oil reservoir simulation community.
 .
 Package provides documentation of the source code of the simulators.

Package: python3-opm-simulators
Section: python
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
#Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, libopm-simulators
Description: Python wrappers for the Open porous media / reservoir simulators
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 opm-simulators provides a research (ebos) and a production (flow) fully
 implicit black-oil simulators, supporting one to three phases and
 supporting solvent and polymer options. It uses cell centered finite
 volume schemes with two point flux approximation and automatic
 differentiation for the discretization and uses state of the art linear
 and nonlinear solvers. It supports standard and multi segment well
 models and reading and writing file in Eclipse format, a very common
 format used in the oil reservoir simulation community.
 .
 Package provides Python wrappers for the simulators.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/architecture.mk

OPM_DEBIAN_CMAKE_FLAGS = -DOPM_ENABLE_PYTHON=1 -DOPM_INSTALL_PYTHON=1 -DPYTHON_EXECUTABLE=/usr/bin/python3 -DOPM_INSTALL_COMPILED_PYTHON=OFF  -DOPM_ENABLE_PYTHON_TESTS=0


%:
	dh $@ --with python3 --max-parallel=1

include /usr/share/opm/opm-debian.mk
include /usr/share/opm/opm-lib-debian.mk # for makeshlibs

=== debian/tests/control ===
Tests: run-flow
Depends:
  libopm-simulators-bin
Restrictions: allow-stderr, skip-not-installable

Tests: run-python-tests
Depends:
  python3-all,
  python3-opm-simulators
Restrictions: allow-stderr, skip-not-installable

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?release/(\d\d\d\d\.\d\d)/final\.tar\.gz%opm-simulators-$1.tar.gz%" \
   https://github.com/OPM/opm-simulators/tags \
   (?:.*?)?release/(\d\d\d\d\.\d\d)/final\.tar\.gz debian uupdate

# Direct Git
# opts="mode=git" http://git.example.com/opm-simulators.git \
#   refs/tags/v([\d\.]+) debian uupdate

## opm-simulators 2022.04+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,15 +21,14 @@
 option(SIBLING_SEARCH "Search for other modules in sibling directories?" ON)
 set( USE_OPENMP_DEFAULT OFF ) # Use of OpenMP is considered experimental
 option(BUILD_FLOW "Build the production oriented flow simulator?" ON)
-option(BUILD_FLOW_BLACKOIL_ONLY "Build the production oriented flow simulator only supporting the blackoil model?" OFF)
 option(BUILD_FLOW_VARIANTS "Build the variants for flow by default?" OFF)
-option(BUILD_EBOS "Build the research oriented ebos simulator?" ON)
-option(BUILD_EBOS_EXTENSIONS "Build the variants for various extensions of ebos by default?" OFF)
-option(BUILD_EBOS_DEBUG_EXTENSIONS "Build the ebos variants which are purely for debugging by default?" OFF)
 option(BUILD_FLOW_POLY_GRID "Build flow blackoil with polyhedral grid" OFF)
 option(OPM_ENABLE_PYTHON "Enable python bindings?" OFF)
 option(OPM_ENABLE_PYTHON_TESTS "Enable tests for the python bindings?" ON)
 option(ENABLE_FPGA "Enable FPGA kernels integration?" OFF)
+option(USE_CHOW_PATEL_ILU "Use the iterative ILU by Chow and Patel?" OFF)
+option(USE_CHOW_PATEL_ILU_GPU "Run iterative ILU decomposition on GPU? Requires USE_CHOW_PATEL_ILU" OFF)
+option(USE_CHOW_PATEL_ILU_GPU_PARALLEL "Try to use more parallelism on the GPU during the iterative ILU decomposition? Requires USE_CHOW_PATEL_ILU_GPU" OFF)
 
 if(SIBLING_SEARCH AND NOT opm-common_DIR)
   # guess the sibling dir
@@ -206,10 +205,32 @@
   if(CL2_HPP)
     set(HAVE_OPENCL 1)
     include_directories(${OpenCL_INCLUDE_DIRS})
+    find_file(OPENCL_HPP CL/opencl.hpp HINTS ${OpenCL_INCLUDE_DIRS})
+    if(OPENCL_HPP)
+      set(HAVE_OPENCL_HPP 1)
+    endif()
   else()
     message(WARNING " OpenCL was found, but this version of opm-simulators relies on CL/cl2.hpp, which implements OpenCL 1.0, 1.1 and 1.2.\n Deactivating OpenCL")
     set(OpenCL_FOUND OFF)
     set(OPENCL_FOUND OFF)
+  endif()
+  if(USE_CHOW_PATEL_ILU)
+    add_compile_options(-DCHOW_PATEL=1)
+    if(USE_CHOW_PATEL_ILU_GPU)
+      add_compile_options(-DCHOW_PATEL_GPU=1)
+      if(USE_CHOW_PATEL_ILU_GPU_PARALLEL)
+        add_compile_options(-DCHOW_PATEL_GPU_PARALLEL=1)
+      else()
+        add_compile_options(-DCHOW_PATEL_GPU_PARALLEL=0)
+      endif()
+    else()
+      add_compile_options(-DCHOW_PATEL_GPU=0)
+      add_compile_options(-DCHOW_PATEL_GPU_PARALLEL=0)
+    endif()
+  endif()
+else()
+  if(USE_CHOW_PATEL_ILU)
+    message(FATAL_ERROR " CHOW_PATEL_ILU only works for openclSolver, but OpenCL was not found")
   endif()
 endif()
 
@@ -235,22 +256,3 @@
     get_property(VEXCL_COMPILE_DEFINITIONS TARGET VexCL::OpenCL PROPERTY INTERFACE_COMPILE_DEFINITIONS)
     set(VEXCL_LINK_LIBRARIES "${VEXCL_LINK_LIBRARIES};OpenCL::OpenCL")
     add_library(OPM::VexCL::OpenCL INTERFACE IMPORTED)
-    set_target_properties(OPM::VexCL::OpenCL PROPERTIES
-      INTERFACE_COMPILE_DEFINITIONS "${VEXCL_COMPILE_DEFINITIONS}"
-      INTERFACE_LINK_LIBRARIES "${VEXCL_LINK_LIBRARIES}")
-    target_include_directories(OPM::VexCL::OpenCL SYSTEM INTERFACE "${VEXCL_INCLUDE_DIRS}")
-  endif()
-endif()
-
-# read the list of components from this file (in the project directory);
-# it should set various lists with the names of the files to include
-include (CMakeLists_files.cmake)
-
-macro (config_hook)
-  opm_need_version_of ("dune-common")
-  opm_need_version_of ("dune-istl")
-  if(dune-fem_FOUND)
-      opm_need_version_of ("dune-fem")
-  endif()
-  opm_need_version_of ("opm-models")
-

=== python/simulators/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,21 @@
 
 target_link_libraries( simulators PRIVATE opmsimulators )
 
-set(PYTHON_PACKAGE_PATH "site-packages")
+execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "
+import site, sys
+try:
+    sys.stdout.write(site.getsitepackages()[-1])
+except e:
+    sys.stdout.write('')" OUTPUT_VARIABLE PYTHON_SITE_PACKAGES_PATH)
+
+if (PYTHON_SITE_PACKAGES_PATH MATCHES ".*/dist-packages/?" AND
+      CMAKE_INSTALL_PREFIX MATCHES "^/usr.*")
+  # dist-packages is only used if we install below /usr and python's site packages
+  # path matches dist-packages
+  set(PYTHON_PACKAGE_PATH "dist-packages")
+else()
+  set(PYTHON_PACKAGE_PATH "site-packages")
+endif()
 set(PYTHON_INSTALL_PREFIX "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/${PYTHON_PACKAGE_PATH}" CACHE STRING "Subdirectory to install Python modules in")
 
 install(TARGETS simulators DESTINATION ${DEST_PREFIX}${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL_PREFIX}/opm)

=== debian/changelog ===
opm-simulators (2022.04+ds-2build1) kinetic; urgency=medium

  * No-change rebuild against libfmt9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 21 Aug 2022 06:07:09 +0000

opm-simulators (2022.04+ds-2) unstable; urgency=medium

  * Changed version in dune.module to 2022.04

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 12 May 2022 14:21:41 +0200

opm-simulators (2022.04+ds-1) unstable; urgency=medium

  * New final upstream release 2022.04
  * d/copyright: Updated copyright and file excludes.
  * d/watch: Advertise repackaging in tarball name



 -- Markus Blatt <markus@dr-blatt.de>  Wed, 11 May 2022 23:18:31 +0200

opm-simulators (2022.04~rc1-2) experimental; urgency=medium

  * d/control: Fix OPM version dependency.

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 28 Apr 2022 12:12:00 +0200

opm-simulators (2022.04~rc1-1) experimental; urgency=medium

  [ Markus Blatt ]
  * New upstream release candidate 2022.04-rc1
  * d/control: Use debhelper-compat (= 12) to support older Ubuntu versions.
  * d/control: Depend on OPM 2022.04.
  * Dropped patches aleady in upstream
  * d/rules: Use -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON for reproducible builds
  * d/rules: Fix pbuilder run without locally installed opm-common.
  * d/control: added zlib1g-dev to Build-Depends to support older Ubuntu

  [ Graham Inggs ]
  * d/rules: Deactivate lto and build serial to avoid FTBS in Ubuntu.

  [ Markus Blatt ]
  * Allow forcing parallel builds via env variable DEBIAN_FORCE_PARALLEL
  * d/copyright: Remove removed files from list.
  * Spelling fix geomtry -> geometry.
  * d/control: Added recommends for upstream OPM binary and python packages

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 28 Apr 2022 10:06:15 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
-Build-Depends: debhelper-compat (= 13), cmake (>=3.10), quilt, dh-python,
+Build-Depends: debhelper-compat (= 12), cmake (>=3.10), quilt, dh-python,
                libboost-system-dev, libboost-date-time-dev, libboost-test-dev,
-               gfortran, pkg-config, git, libtool, doxygen,
+               zlib1g-dev, gfortran, pkg-config, git, libtool, doxygen,
                texlive-latex-extra, texlive-latex-recommended, ghostscript,
-               libopm-grid-dev (>=2021.10), libopm-models-dev (>=2021.10),  mpi-default-dev, mpi-default-bin,
+               libopm-grid-dev (>= 2022.04), libopm-models-dev (>= 2022.04),  mpi-default-dev, mpi-default-bin,
                python3-dev, libpython3-dev, python3-distutils, pybind11-dev
 Standards-Version: 4.6.0
 Section: libs
@@ -20,8 +20,8 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>=2021.10),
-         libopm-models-dev (>=2021.10), libboost-date-time-dev
+Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2022.04),
+         libopm-models-dev (>= 2022.04), libboost-date-time-dev
 Replaces: libopm-simulators1-dev
 Suggests: libopm-simulators-doc
 Description: Parallel porous media / reservoir simulators -- development files
@@ -71,6 +71,7 @@
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: libopm-simulators1-bin
+Recommends: libopm-grid-bin, libopm-common-bin
 Description: Parallel porous media / reservoir simulators -- applications
  The Open Porous Media (OPM) software suite provides libraries and
  tools for modeling and simulation of porous media processes, especially
@@ -115,6 +116,7 @@
 Architecture: any
 #Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, libopm-simulators
+Recommends: python3-opm-common
 Description: Python wrappers for the Open porous media / reservoir simulators
  The Open Porous Media (OPM) software suite provides libraries and
  tools for modeling and simulation of porous media processes, especially

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS+=optimize=-lto

include /usr/share/dpkg/architecture.mk

OPM_DEBIAN_CMAKE_FLAGS = -DOPM_ENABLE_PYTHON=1 -DOPM_INSTALL_PYTHON=1 -DPYTHON_EXECUTABLE=/usr/bin/python3 -DOPM_INSTALL_COMPILED_PYTHON=OFF  -DOPM_ENABLE_PYTHON_TESTS=0 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON


OPM_DEBIAN_MK ?= /usr/share/opm/opm-debian.mk
ifneq ("$(wildcard $(OPM_DEBIAN_MK))","")
   include $(OPM_DEBIAN_MK)
endif
OPM_LIB_DEBIAN_MK ?= /usr/share/opm/opm-lib-debian.mk
ifneq ("$(wildcard $(OPM_LIB_DEBIAN_MK))","")
    include $(OPM_LIB_DEBIAN_MK) # for makeshlibs
endif

# Set DEBIAN_FORCE_PARALLEL to compile in parallel
ifeq ($(strip $(DEBIAN_FORCE_PARALLEL)),)
   DEB_PARALLEL="--max-parallel=1"
endif

%:
	dh $@ --with python3 $(DEB_PARALLEL)

## opm-simulators 2022.10~rc1+ds

=== debian/changelog ===
opm-simulators (2022.10~rc1+ds-1) experimental; urgency=medium

  * New upstream release candidate 2022.10~rc1
  * d/control: Updated OPM dependency to 2022.10~
  * Rediff patches to fix compilation
  * Fixed typo: acess -> access
  * Use SKIP_BUILD_RPATH for python lib of simulators
  * d: updated copyright

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 04 Nov 2022 10:23:08 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: opm-simulators
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
 Build-Depends: debhelper-compat (= 12), cmake (>=3.10), quilt, dh-python,
                libboost-system-dev, libboost-date-time-dev, libboost-test-dev,
                zlib1g-dev, gfortran, pkg-config, git, libtool, doxygen,
                texlive-latex-extra, texlive-latex-recommended, ghostscript,
-               libopm-grid-dev (>= 2022.04), libopm-models-dev (>= 2022.04),  mpi-default-dev, mpi-default-bin,
+               libopm-grid-dev (>= 2022.10~), libopm-models-dev (>= 2022.10~),  mpi-default-dev, mpi-default-bin,
                python3-dev, libpython3-dev, python3-distutils, pybind11-dev
 Standards-Version: 4.6.0
 Section: libs
@@ -20,8 +19,8 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2022.04),
-         libopm-models-dev (>= 2022.04), libboost-date-time-dev
+Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2022.10~),
+         libopm-models-dev (>= 2022.10~), libboost-date-time-dev
 Replaces: libopm-simulators1-dev
 Suggests: libopm-simulators-doc
 Description: Parallel porous media / reservoir simulators -- development files

## opm-simulators 2022.10+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,10 +25,44 @@
 option(BUILD_FLOW_POLY_GRID "Build flow blackoil with polyhedral grid" OFF)
 option(OPM_ENABLE_PYTHON "Enable python bindings?" OFF)
 option(OPM_ENABLE_PYTHON_TESTS "Enable tests for the python bindings?" ON)
+option(OPM_INSTALL_PYTHON "Install python bindings?" ON)
 option(ENABLE_FPGA "Enable FPGA kernels integration?" OFF)
 option(USE_CHOW_PATEL_ILU "Use the iterative ILU by Chow and Patel?" OFF)
 option(USE_CHOW_PATEL_ILU_GPU "Run iterative ILU decomposition on GPU? Requires USE_CHOW_PATEL_ILU" OFF)
 option(USE_CHOW_PATEL_ILU_GPU_PARALLEL "Try to use more parallelism on the GPU during the iterative ILU decomposition? Requires USE_CHOW_PATEL_ILU_GPU" OFF)
+option(BUILD_FLOW_ALU_GRID "Build flow blackoil with alu grid" OFF)
+option(USE_DAMARIS_LIB "Use the Damaris library for asynchronous I/O?" OFF)
+
+# The following was copied from CMakeLists.txt in opm-common.
+# TODO: factor out the common parts in opm-common and opm-simulator as a cmake module
+if (OPM_ENABLE_PYTHON)
+  # We need to be compatible with older CMake versions
+  # that do not offer FindPython3
+  # e.g. Ubuntu LTS 18.04 uses cmake 3.10
+  if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
+    find_package(PythonInterp REQUIRED)
+    if(PYTHON_VERSION_MAJOR LESS 3)
+      message(SEND_ERROR "OPM requires version 3 of Python but only version ${PYTHON_VERSION_STRING} was found")
+    endif()
+    set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
+    set(Python3_LIBRARIES ${PYTHON_LIBRARIES})
+    set(Python3_VERSION "${PYTHON_VERSION_STRING}")
+    set(Python3_VERSION_MINOR ${PYTHON_VERSION_MINOR})
+  else()
+    # Be backwards compatible.
+    if(PYTHON_EXECUTABLE AND NOT Python3_EXECUTABLE)
+      set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
+    endif()
+    find_package(Python3 REQUIRED COMPONENTS Interpreter Development)
+  endif()
+  if(Python3_VERSION_MINOR LESS 3)
+    # Python native namespace packages requires python >= 3.3
+    message(SEND_ERROR "OPM requires python >= 3.3 but only version ${Python3_VERSION} was found")
+  endif()
+  # Compatibility settings for PythonInterp and PythonLibs
+  # used e.g. in FindCwrap, pybind11
+  set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})
+endif()
 
 if(SIBLING_SEARCH AND NOT opm-common_DIR)
   # guess the sibling dir
@@ -217,42 +251,3 @@
   if(USE_CHOW_PATEL_ILU)
     add_compile_options(-DCHOW_PATEL=1)
     if(USE_CHOW_PATEL_ILU_GPU)
-      add_compile_options(-DCHOW_PATEL_GPU=1)
-      if(USE_CHOW_PATEL_ILU_GPU_PARALLEL)
-        add_compile_options(-DCHOW_PATEL_GPU_PARALLEL=1)
-      else()
-        add_compile_options(-DCHOW_PATEL_GPU_PARALLEL=0)
-      endif()
-    else()
-      add_compile_options(-DCHOW_PATEL_GPU=0)
-      add_compile_options(-DCHOW_PATEL_GPU_PARALLEL=0)
-    endif()
-  endif()
-else()
-  if(USE_CHOW_PATEL_ILU)
-    message(FATAL_ERROR " CHOW_PATEL_ILU only works for openclSolver, but OpenCL was not found")
-  endif()
-endif()
-
-find_package(amgcl)
-if(amgcl_FOUND)
-  set(HAVE_AMGCL 1)
-  # Linking to target angcl::amgcl drags in OpenMP and -fopenmp as a compile
-  # flag. With that nvcc fails as it does not that flag.
-  # Hence we set AMGCL_INCLUDE_DIRS.
-  get_property(AMGCL_INCLUDE_DIRS TARGET amgcl::amgcl PROPERTY INTERFACE_INCLUDE_DIRECTORIES)
-  include_directories(SYSTEM ${AMGCL_INCLUDE_DIRS})
-endif()
-
-if(OpenCL_FOUND)
-  find_package(VexCL)
-  if(VexCL_FOUND)
-    set(HAVE_VEXCL 1)
-    # generator expressions in vexcl do not seem to work and therefore
-    # we cannot use the imported target. Hence we exract the needed info
-    # from the targets
-    get_property(VEXCL_INCLUDE_DIRS TARGET VexCL::Common PROPERTY INTERFACE_INCLUDE_DIRECTORIES)
-    get_property(VEXCL_LINK_LIBRARIES TARGET VexCL::Common PROPERTY INTERFACE_LINK_LIBRARIES)
-    get_property(VEXCL_COMPILE_DEFINITIONS TARGET VexCL::OpenCL PROPERTY INTERFACE_COMPILE_DEFINITIONS)
-    set(VEXCL_LINK_LIBRARIES "${VEXCL_LINK_LIBRARIES};OpenCL::OpenCL")
-    add_library(OPM::VexCL::OpenCL INTERFACE IMPORTED)

=== python/CMakeLists.txt ===
find_package(pybind11 2.2 CONFIG)

if(NOT pybind11_FOUND)
  add_subdirectory( pybind11 )
  # SYSTEM is supported for embedded pybind source (>= 2.3.0)
  set(PYBIND11_SYSTEM "SYSTEM")
elseif(pybind11_VERSION VERSION_GREATER_EQUAL "2.3.0")
  if(CMAKE_VERSION VERSION_LESS 3.12)
    # SYSTEM is only support for pybind >= 2.3.0 and cmake <= 3.12.0 (Unfortunately querying the
    # version does not work. AT least we know the embedded one.
    set(PYBIND11_SYSTEM "SYSTEM")
  endif()
endif()
add_subdirectory( simulators )

=== python/simulators/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,5 @@
-# NOTE: we assume that add_subdirectory( pybind11 ) is called from the
-#    parent folder's CMakeLists.txt before this CMakeLists.txt is loaded.
-#    Therefore, pybind11's CMakeLists.txt has already run
-#    find_package(PYTHON) to define variables like ${PYTHON_EXECUTABLE}
+#  Note: If the new find_package(Python3) is used in the top level CMakeLists.txt, the variable
+#    ${PYTHON_EXECUTABLE} is set there to ${Python3_EXECUTABLE}
 #
 # NOTE: The variable ${PYBIND11_SYSTEM} is set in python/CMakeLists.txt
 #   to the value "SYSTEM" or unset, depending on the current version of Pybind11.
@@ -14,7 +12,8 @@
   PyBlackOilSimulator.cpp
   Pybind11Exporter.cpp)
 
-set_target_properties( simulators PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/python/opm2 )
+set(PYTHON_OPM_SIMULATORS_PACKAGE_PATH ${PROJECT_BINARY_DIR}/python/opm/simulators)
+set_target_properties( simulators PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PYTHON_OPM_SIMULATORS_PACKAGE_PATH} )
 
 target_sources(simulators
   PRIVATE
@@ -38,19 +37,8 @@
 else()
   set(PYTHON_PACKAGE_PATH "site-packages")
 endif()
-set(PYTHON_INSTALL_PREFIX "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/${PYTHON_PACKAGE_PATH}" CACHE STRING "Subdirectory to install Python modules in")
-
-install(TARGETS simulators DESTINATION ${DEST_PREFIX}${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL_PREFIX}/opm)
-
-file( COPY ${PROJECT_SOURCE_DIR}/python/test
-      DESTINATION ${PROJECT_BINARY_DIR}/python)
-file( COPY ${PROJECT_SOURCE_DIR}/python/test_data
-      DESTINATION ${PROJECT_BINARY_DIR}/python)
 
 if(OPM_ENABLE_PYTHON_TESTS)
-  if(Python3_EXECUTABLE AND NOT PYTHON_EXECUTABLE)
-    set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})
-  endif()
   set(PYTHON_PATH ${PROJECT_BINARY_DIR}/python:${opm-common_DIR}/python:$ENV{PYTHONPATH})
   # NOTE: See comment in test_basic.py for the reason why we are
   #   splitting the python tests into multiple add_test() tests instead
@@ -67,3 +55,35 @@
       -E env PYTHONPATH=${PYTHON_PATH} ${PYTHON_EXECUTABLE}
       -m unittest test/test_schedule.py)
 endif()
+
+find_file(PYTHON_INSTALL_PY install.py
+  PATHS ${opm-common_DIR} ${opm-common_PYTHON_COMMON_DIR}
+  PATH_SUFFIXES python NO_DEFAULT_PATH REQUIRED)
+
+# NOTE: instead of using file( COPY ...) which copies the files at configure time (not at build time)
+#  we should add copying of the files at build time such that running "make" or "make all" will
+#  update the files if they have been modified. We use the install.py script in opm-common, see also
+#  CMakeLists.txt in opm-common
+add_custom_target(copy_python ALL
+    COMMAND ${PYTHON_EXECUTABLE} "${PYTHON_INSTALL_PY}"
+        ${PROJECT_SOURCE_DIR}/python/opm ${PROJECT_BINARY_DIR}/python 0
+    COMMAND ${PYTHON_EXECUTABLE} "${PYTHON_INSTALL_PY}"
+        ${PROJECT_SOURCE_DIR}/python/test ${PROJECT_BINARY_DIR}/python 0
+    COMMAND ${PYTHON_EXECUTABLE} "${PYTHON_INSTALL_PY}"
+        ${PROJECT_SOURCE_DIR}/python/test_data ${PROJECT_BINARY_DIR}/python 0
+)
+
+# Since the installation of Python code is nonstandard it is protected by an
+# extra cmake switch, OPM_INSTALL_PYTHON. If you prefer you can still invoke
+# setup.py install manually - optionally with the generated script
+# setup-install.sh - and completely bypass cmake in the installation phase.
+if (OPM_INSTALL_PYTHON)
+  include(PyInstallPrefix)  # from opm-common
+  install(TARGETS simulators DESTINATION ${DEST_PREFIX}${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL_PREFIX}/opm)
+  install(
+    CODE "execute_process(
+      COMMAND ${PYTHON_EXECUTABLE}
+              ${PYTHON_INSTALL_PY}
+              ${PROJECT_BINARY_DIR}/python/opm
+              ${DEST_PREFIX}${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL_PREFIX} 1)")
+endif()

=== debian/changelog ===
opm-simulators (2022.10+ds-2) unstable; urgency=medium

  * d/rules: Require 4GB of RAM per make process
  * [cmake]  Work around missing imported Alberta targets.
  * d/control: Fixed version string used in binaries.

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 09 Mar 2023 13:31:04 +0100

opm-simulators (2022.10+ds-1) unstable; urgency=medium

  * New upstream version 2022.10
  * d/control: Bump version dependency on OPM modules.

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 15 Nov 2022 16:51:17 +0100

opm-simulators (2022.10~rc2+ds-1) experimental; urgency=medium

  * New upstream release candidate 2022.10-rc2
  * d/tests: depend on same version of packages for autopkgtest.

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 08 Nov 2022 21:11:51 +0100

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
 Build-Depends: debhelper-compat (= 12), cmake (>=3.10), quilt, dh-python,
                libboost-system-dev, libboost-date-time-dev, libboost-test-dev,
-               zlib1g-dev, gfortran, pkg-config, git, libtool, doxygen,
+               zlib1g-dev, gfortran, pkg-config, lsb-release, libtool, doxygen,
                texlive-latex-extra, texlive-latex-recommended, ghostscript,
-               libopm-grid-dev (>= 2022.10~), libopm-models-dev (>= 2022.10~),  mpi-default-dev, mpi-default-bin,
+               libopm-grid-dev (>= 2022.10), libopm-models-dev (>= 2022.10),  mpi-default-dev, mpi-default-bin,
                python3-dev, libpython3-dev, python3-distutils, pybind11-dev
 Standards-Version: 4.6.0
 Section: libs
@@ -19,8 +19,8 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2022.10~),
-         libopm-models-dev (>= 2022.10~), libboost-date-time-dev
+Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2022.10),
+         libopm-models-dev (>= 2022.10), libboost-date-time-dev
 Replaces: libopm-simulators1-dev
 Suggests: libopm-simulators-doc
 Description: Parallel porous media / reservoir simulators -- development files

=== debian/rules ===
--- 
+++ 
@@ -18,10 +18,12 @@
     include $(OPM_LIB_DEBIAN_MK) # for makeshlibs
 endif
 
-# Set DEBIAN_FORCE_PARALLEL to compile in parallel
-ifeq ($(strip $(DEBIAN_FORCE_PARALLEL)),)
-   DEB_PARALLEL="--max-parallel=1"
-endif
+# require 4GB of RAM per make process
+need_gb_ram_per_process=4
+free_ram=$(shell free -g | sed -n 2p| sed "s/ \+/ /g"| cut -d " " -f 2)
+max_procs=$(shell echo "$(free_ram)/$(need_gb_ram_per_process)" | bc)
+parallel_procs=$(shell if test "$(max_procs)" -lt "1"; then echo 1; else echo "$(max_procs)"; fi)
 
 %:
-	dh $@ --with python3 $(DEB_PARALLEL)
+	echo "ram in gb: $(free_ram), needed ram per thread: $(need_gb_ram_per_process), threads: $(parallel_procs)"
+	dh $@ --with python3 --max-parallel=$(parallel_procs)

=== debian/watch ===
--- 
+++ 
@@ -5,7 +5,7 @@
 #opts="pgpsigurlmangle=s%$%.sig%"
 
 # GitHub hosted projects
-opts="filenamemangle=s%(?:.*?)?release/(\d\d\d\d\.\d\d)/final\.tar\.gz%opm-simulators-$1.tar.gz%" \
+opts="filenamemangle=s%(?:.*?)?release/(\d\d\d\d\.\d\d)/final\.tar\.gz%opm-simulators-$1.tar.gz%,oversionmangle=s/(.*)/$1+ds/,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//" \
    https://github.com/OPM/opm-simulators/tags \
    (?:.*?)?release/(\d\d\d\d\.\d\d)/final\.tar\.gz debian uupdate
